<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Users CRUD Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>

<body class="hold-transition dark-mode sidebar-mini layout-fixed layout-navbar-fixed">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-dark">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>

      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="#" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DEVCAMP 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Quang Hân</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Users</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="product.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Products</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Orders</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>USERS CRUD</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Users</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
      <div class="container-fluid p-3">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h2><span class="border-bottom"><b>REGISTER USER</b></span></h2>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <button id="btn-new-user" class="btn btn-primary"><i class="fa fa-plus"></i> New User</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <table id="table-user" class="table table-bordered table-striped table-hover">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>Firstname</th>
                            <th>Lastname</th>
                            <th>Country</th>
                            <th>Subject</th>
                            <th>Customer Type</th>
                            <th>Register Staus</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
        <!-- Modal Create New User -->
        <div>
            <div id="modal-new-user" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">NEW USER</h5>
                            <a role="button" class="close" data-dismiss="modal">&times;</a>
                        </div>
                        <div class="modal-body">
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-firstname" class="form-control" placeholder="Firstname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-lastname" class="form-control" placeholder="Lastname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-country" class="form-control">
                                        <option value="none">Country ...</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <textarea id="inp-subject" class="form-control" placeholder="Subject ..."></textarea>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-type" class="form-control">
                                        <option value="none">Customer Type ...</option>
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-success create-user">Tạo User</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Modal Update User -->
        <div>
            <div id="modal-update-user" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">USER DETAIL</h5>
                            <a role="button" class="close" data-dismiss="modal">&times;</a>
                        </div>
                        <div class="modal-body">
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-update-firstname" class="form-control" placeholder="Firstname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-update-lastname" class="form-control" placeholder="Lastname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-country" class="form-control">
                                        <option value="none">Country ...</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <textarea id="inp-update-subject" class="form-control" placeholder="Subject ..."></textarea>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-type" class="form-control">
                                        <option value="none">Customer Type ...</option>
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Register Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-status" class="form-control">
                                        <option value="none">Register Status ...</option>
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-success update-user">Update User</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Modal Delete User -->
        <div>
            <div id="modal-delete-user" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">DELETE USER</h5>
                            <a role="button" class="close" data-dismiss="modal">&times;</a>
                        </div>
                        <div class="modal-body">
                            <p>Xác nhận xóa thông tin user?</p>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger confirm-delete-user">Confirm Delete</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Main content -->
    <section class="content">
      
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0
    </div>
    <strong>Copyright &copy; 2023 <a href="#">Devcamp 120</a>.</strong> All rights reserved.
  </footer>

</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- Import Datatable sau jquery -->
<!-- Import them style bootstrap cho datatable -->
<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
  const gCONTENT_TYPE = "application/json;charset=UTF-8";

  const gHEADER_ROW = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
  const gID_COL = 0;
  const gFIRSTNAME_COL = 1;
  const gLASTNAME_COL = 2;
  const gCOUNTRY_COL = 3;
  const gSUBJECT_COL = 4;
  const gTYPE_COL = 5;
  const gSTATUS_COL = 6;
  const gACTION_COL = 7;

  var gUserId = 0;

  var gTableUser = $("#table-user").DataTable({
      columns: [
          {data: gHEADER_ROW[gID_COL]},
          {data: gHEADER_ROW[gFIRSTNAME_COL]},
          {data: gHEADER_ROW[gLASTNAME_COL]},
          {data: gHEADER_ROW[gCOUNTRY_COL]},
          {data: gHEADER_ROW[gSUBJECT_COL]},
          {data: gHEADER_ROW[gTYPE_COL]},
          {data: gHEADER_ROW[gSTATUS_COL]},
          {data: gHEADER_ROW[gACTION_COL]},
      ],
      columnDefs: [
          {
              targets: gACTION_COL,
              className: 'text-nowrap',
              defaultContent: `
                  <button class="btn btn-primary edit-user">Sửa</button>
                  <button class="btn btn-danger delete-user">Xóa</button>
              `
          }
      ]
  })

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  // gán sự kiện load trang
  $(document).ready(onPageLoading);

  // gán sự kiện click button Sửa
  $(document).on("click", ".edit-user", function() {
      onBtnEditClick(this);
  });
  // gán sự kiện click button Update User (trên modal update user)
  $(document).on("click", ".update-user", onBtnUpdateUserClick);

  // gán sự kiện click button Xóa
  $(document).on("click", ".delete-user", function() {
      onBtnDeleteClick(this);
  });
  // gán sự kiện click button Update User (trên modal delete user)
  $(document).on("click", ".confirm-delete-user", onBtnConfirmDeleteClick);

  // gán sự kiện click button New User
  $("#btn-new-user").on("click", onBtnNewUserClick);
  // gán sự kiện click button Tạo User (trên modal new user)
  $(document).on("click", ".create-user", onBtnCreateUserClick);
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // function xử lý sự kiện load trang/F5
  function onPageLoading() {
      // lấy user list và hiển thị vào table
      getUserListAndDisplayDataTable();
  }

  // function xử lý sự kiện click button New User
  function onBtnNewUserClick() {
      // hiện modal New User
      $("#modal-new-user").modal("show");
  }
  // function xử lý sự kiện click button Create User (trên modal New User)
  function onBtnCreateUserClick() {
      console.log("%cBUTTON CREATE USER - CLICK", "color: green");
      // khai báo đối tượng chứa dữ liệu
      let vUserData = {
          firstname: "",
          lastname: "",
          country: "",
          subject: "",
          customerType: ""
      };
      // B1: Thu thập dữ liệu
      getNewUserData(vUserData);
      // B2: Kiểm tra dữ liệu
      let vDataValid = checkUserData(vUserData);
      if (vDataValid) {
          // B3: Gọi API tạo user mới
          let vAjaxRequest = apiCreateUser(vUserData);
          vAjaxRequest.done(function(vResponse) {
              // B4: Xử lý hiển thị
              handleCreateUserSuccess();
          })
      }

  }

  // function xử lý sự kiện click button Sửa
  function onBtnEditClick(paramButton) {
      console.log("%cBUTTON SỬA - CLICK", "color: blue");
      // B1: Thu thập dữ liệu
      getUserId(paramButton);
      console.log("User ID: " + gUserId);
      // B3: Gọi API lấy thông tin user bằng ID
      let vAjaxRequest = apiGetUserDetailById();
      vAjaxRequest.done(function(vResponse) {
          // B4: Xử lý hiển thị
          console.log(vResponse);
          $("#modal-update-user").modal("show");
          displayUserDetail(vResponse);
      })
  }
  // function xử lý sự kiện click button Update User (trên modal Update User)
  function onBtnUpdateUserClick() {
      console.log("%cBUTTON UPDATE USER - CLICK", "color: green");
      // khai báo đối tượng chứa dữ liệu
      let vUserData = {
          firstname: "",
          lastname: "",
          country: "",
          subject: "",
          customerType: "",
          registerStatus: "",
      };
      // B1: Thu thập dữ liệu
      getUpdateUserData(vUserData);
      // B2: Kiểm tra dữ liệu
      let vDataValid = checkUserData(vUserData);
      console.log("Validate result: " + vDataValid);
      if (vDataValid) {
          // B3: Gọi API update user detail
          console.log(vUserData);
          let vAjaxRequest = apiUpdateUserDetail(vUserData);
          // B4: Xử lý hiển thị
          vAjaxRequest.done(handleUpdateUserSuccess)
      }
  }

  // function xử lý sự kiện click button Xóa
  function onBtnDeleteClick(paramButton) {
      console.log("%cBUTTON XÓA - CLICK", "color: red");
      // Thu thập dữ liệu
      getUserId(paramButton);
      console.log("User ID: " + gUserId);
      // Xử lý hiển thị
      $("#modal-delete-user").modal("show");
  }
  // function xử lý sự kiện click button Confirm Delete (trên modal Delete User)
  function onBtnConfirmDeleteClick() {
      // B1: Thu thập dữ liệu
      // B2: Kiểm tra dữ liệu
      // B3: Gọi API xóa user
      let vAjaxRequest = apiDeleteUser();
      // B4: Xử lý hiển thị
      vAjaxRequest.done(handleDeleteUserSuccess);
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function gọi API lấy danh sách user
  function apiGetUserList() {
      return $.ajax({
          url: gBASE_URL,
          type: "GET",
      });
  }

  //function gọi API tạo user mới
  function apiCreateUser(paramUserData) {
      return $.ajax({
          url: gBASE_URL,
          type: "POST",
          data: JSON.stringify(paramUserData),
          contentType: gCONTENT_TYPE,
      });
  }

  // function gọi API lấy thông tin user bằng ID
  function apiGetUserDetailById() {
      return $.ajax({
          url: gBASE_URL + gUserId,
          type: "GET",
      });
  }

  // function gọi API update user detail
  function apiUpdateUserDetail(paramUserDetail) {
      return $.ajax({
          url: gBASE_URL + gUserId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(paramUserDetail),
      });
  }

  // function gọi API xóa user
  function apiDeleteUser() {
      return $.ajax({
          url: gBASE_URL + gUserId,
          type: "DELETE",
      });
  }

  // function lấy user list và hiển thị vào table
  function getUserListAndDisplayDataTable() {
      let vAjaxRequest = apiGetUserList();
      vAjaxRequest.done(function(vResponse) {
          displayTableUser(vResponse);
      });
  }

  // function hiển thị table user
  function displayTableUser(paramUserList) {
      gTableUser.clear();
      gTableUser.rows.add(paramUserList);
      gTableUser.draw();
  }

  // function thu thập user ID khi click button Sửa/Xóa
  function getUserId(paramButton) {
      let vRowClick = $(paramButton).closest("tr");
      gUserId = gTableUser.row(vRowClick).data().id;
  }

  // function thu thập dữ liệu user trên modal New User
  // function trả về đối tượng paramUserData được tham số hóa
  function getNewUserData(paramUserData) {
      paramUserData.firstname = $("#inp-firstname").val().trim();
      paramUserData.lastname = $("#inp-lastname").val().trim();
      paramUserData.country = $("#select-country").val();
      paramUserData.subject = $("#inp-subject").val().trim();
      paramUserData.customerType = $("#select-type").val();
  }

  // function thu thập dữ liệu user trên modal Update User
  // function trả về đối tượng paramUserData được tham số hóa
  function getUpdateUserData(paramUserData) {
      paramUserData.firstname = $("#inp-update-firstname").val().trim();
      paramUserData.lastname = $("#inp-update-lastname").val().trim();
      paramUserData.country = $("#select-update-country").val();
      paramUserData.subject = $("#inp-update-subject").val().trim();
      paramUserData.customerType = $("#select-update-type").val();
      paramUserData.registerStatus = $("#select-update-status").val();
  }

  // function kiểm tra dữ liệu user trên form
  // function return true nếu tất cả dữ liệu hợp lệ, return false nếu có dữ liệu không hợp lệ
  function checkUserData(paramUserData) {
      if (paramUserData.firstname === "") {
          alert("Vui lòng nhập firstname");
          return false;
      }
      else if (paramUserData.lastname === "") {
          alert("Vui lòng nhập lastname");
          return false;
      }
      else if (paramUserData.country === "none") {
          alert("Vui lòng chọn country");
          return false;
      }
      else if (paramUserData.subject === "") {
          alert("Vui lòng nhập subject");
          return false;
      }
      else if (paramUserData.customerType === "none") {
          alert("Vui lòng chọn customer type");
          return false;
      }
      else if (paramUserData.registerStatus === "none") {
          alert("Vui lòng chọn register status");
          return false;
      }
      return true;
  }

  // function hiển thị user detail lên form modal update user
  function displayUserDetail(paramUserDetail) {
      $("#inp-update-firstname").val(paramUserDetail.firstname);
      $("#inp-update-lastname").val(paramUserDetail.lastname);
      $("#select-update-country").val(paramUserDetail.country);
      $("#inp-update-subject").val(paramUserDetail.subject);
      $("#select-update-type").val(paramUserDetail.customerType);
      $("#select-update-status").val(paramUserDetail.registerStatus);
  }

  // function xử lý hiển thị tạo user mới thành công
  function handleCreateUserSuccess() {
      // thông báo thành công
      alert("Tạo user mới thành công");
      // xóa trắng thông tin trên modal new user
      resetModalNewUserInputField();
      // tải lại user list table
      getUserListAndDisplayDataTable();
      // ẩn modal
      $("#modal-new-user").modal("hide");
  }

  // function xử lý hiển thị update user thành công
  function handleUpdateUserSuccess() {
      // thông báo thành công
      alert("Update user thành công");
      // tải lại user list table
      getUserListAndDisplayDataTable();
      // ẩn modal
      $("#modal-update-user").modal("hide");
  }

  // function xử lý hiển thị delete user thành công
  function handleDeleteUserSuccess() {
      // thông báo thành công
      alert("Delete user thành công");
      // tải lại user list table
      getUserListAndDisplayDataTable();
      // ẩn modal
      $("#modal-delete-user").modal("hide");
  }

  // function reset input field trên modal new user
  function resetModalNewUserInputField() {
      $("#inp-firstname").val("");
      $("#inp-lastname").val("");
      $("#select-country").val("none");
      $("#inp-subject").val("");
      $("#select-type").val("none");
  }


</script>

</body>

</html>
